# Сборка WinPE

## Загрузка SDK

[Создание загрузочного носителя Windows PE](https://learn.microsoft.com/ru-ru/windows-hardware/manufacture/desktop/winpe-create-usb-bootable-drive?view=windows-10) на сайте Microsoft.

[Загрузить ADK](https://learn.microsoft.com/ru-ru/windows-hardware/get-started/adk-install#choose-the-right-adk-for-your-scenario):
- [ADK 10.1.25398.1](https://go.microsoft.com/fwlink/?linkid=2243390)
- [дополнение Windows PE для ADK 10.1.25398.1](https://go.microsoft.com/fwlink/?linkid=2243391)

## Создание образа

После установки SDK запустить от имени администратора `Среда средств развертывания и работы с образами` в меню `Пуск`.

Выполнить инструкции по копированию и монтированию образа для своей архитектуры. На примере `amd64`:

```powershell
copype amd64 C:\\winpe
Dism /Mount-Image /ImageFile:"C:\\winpe\\media\\sources\\boot.wim" /Index:1 /MountDir:"C:\\winpe\\mount"
```

## Установка дополнений

Установка дополнений в смонтированный образ:

```powershell
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\WinPE-WMI.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\WinPE-NetFX.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\WinPE-Scripting.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\WinPE-PowerShell.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\WinPE-StorageWMI.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\WinPE-DismCmdlets.cab"
```

### Настройка языка

Для дополнений установить языковые пакеты для своего языка:

```powershell
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\ru-ru\\WinPE-WMI_ru-ru.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\ru-ru\\WinPE-NetFX_ru-ru.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\ru-ru\\WinPE-Scripting_ru-ru.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\ru-ru\\WinPE-PowerShell_ru-ru.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\ru-ru\\WinPE-StorageWMI_ru-ru.cab"
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\ru-ru\\WinPE-DismCmdlets_ru-ru.cab"
```

Установка языкового пакета и активация поддержки языка:

```powershell
Dism /Add-Package /Image:"C:\\winpe\\mount" /PackagePath:"C:\\Program Files (x86)\\Windows Kits\\10\\Assessment and Deployment Kit\\Windows Preinstallation Environment\\amd64\\WinPE_OCs\\ru-ru\\lp.cab"
Dism /Image:"C:\\winpe\\mount" /Set-uilang:ru-RU
```

### Установка драйверов

Создать директорию, например `C:\drivers` и поместить в неё необходимые драйвера для включения их в WinPE:

```powershell
Dism /Image:"C:\\winpe\\mount" /Add-Driver:"C:\\drivers" /recurse /forceunsigned
```

## Разрешить установку Windows 11

Из под WinPE разрешить инсталлировать Windows 11. Добавить в реестр образа необходмую информацию:

```powershell
reg load HKLM\WIM_REG "C:\winpe\mount\Windows\System32\config\SOFTWARE"
reg add HKLM\WIM_REG\Microsoft\Windows\CurrentVersion\OOBE /v BypassNRO /t REG_DWORD /d 1 /f
reg unload HKLM\WIM_REG
reg load HKLM\WIM_REG "C:\winpe\mount\Windows\System32\config\SYSTEM"
reg add HKLM\WIM_REG\Setup\LabConfig /v BypassTPMCheck /t REG_DWORD /d 1 /f
reg add HKLM\WIM_REG\Setup\LabConfig /v BypassSecureBootCheck  /t REG_DWORD /d 1 /f
reg unload HKLM\WIM_REG
```

## Применение изменений и размонтирование образа

Для завершения внесения изменений и сохранения образа выполнить:

```powershell
Dism /Unmount-Image /MountDir:C:\\winpe\\mount /Commit
```
